#!/System/Index/bin/ruby -w
# Encoding: ISO-8859-1
# frozen_string_literal: true
# =========================================================================== #
require 'pp'
require 'colour_e/autoinclude'
require 'cookbooks/sanitize_cookbook_dataset/sanitize_cookbook_dataset.rb'
require 'cookbooks'
require 'cliner'
require 'verbose_truth/autoinclude'
e
e 'We will now test the various classes of the Cookbooks project.'
e
e 'Stay tuned.'
e
e 'The home directory is at:'
e
e '  '+sfancy(Cookbooks.home_dir?)
e
e 'The project base directory (from the constant Cookbooks::PROJECT_BASE_DIRECTORY)is at: '
e
e '  '+sfancy(Cookbooks.project_base_dir?)
e
e 'The project yaml directory is at: '
e
e '  '+sfancy(Cookbooks.project_yaml_dir?)
e
e 'The cookbooks configuration directory is at:'
e
e '  '+sfancy(Cookbooks.cookbooks_configuration_dir?)
e
e 'The individual cookbooks are kept here:'
e
e '  '+sfancy(Cookbooks.individual_cookbooks_directory?)
e
e 'The configuration that will be used is:'
e
pp Cookbooks.configuration?.system_directory
e
cliner
e 'Next, we try to find out whether the above has correctly'
e 'defined several constants:'
begin
  array = [
    Cookbooks::CHECK_FOR_BINARY_NAMES,
    Cookbooks::CHECK_FOR_LIBRARY_NAMES,
    Cookbooks::STORE_INTO_THIS_DIRECTORY
  ]
  array.each {|entry| e '  '+entry.to_s }
rescue Exception => error
  p error; p error.class
end
e 'The system directory is: '+sfancy(Cookbooks.system_directory?)
e
e 'The PII hash constant is having this dataset (we show only one entry):'
pp Cookbooks.pii?.fetch 'RINSTALL4'
e
cliner
e

e 'Cookbooks::COOKBOOK_ALIASES (A hash)'
pp 'vesa  -> '+Cookbooks::COOKBOOK_ALIASES['vesa']
pp 'xfwm  -> '+Cookbooks::COOKBOOK_ALIASES['xfwm']
pp 'xfce4 -> '+Cookbooks::COOKBOOK_ALIASES['xfce4']
e '^^^ The above were 3 entries fom Cookbooks::COOKBOOK_ALIASES'+"\n\n"
# Testing Cookbooks.find_url_for() next.
e 'Next we will find the URL for php:' 
e '  '+sfancy(Cookbooks.find_url_for('php'))
e
cliner
e 'The available utility scripts are:'
Cookbooks.show_available_utility_scripts
cliner
e
# =========================================================================== #
# Testing class Highest here.
# =========================================================================== #
cliner {
  e 'Testing class Highest next:'
}
Cookbooks.highest :display_twenty_programs
cliner; e
# =========================================================================== #
# Testing class BLFS here (which gives us the link of the BLFS entry).
# =========================================================================== #
cliner {
  e 'Testing class BLFS next (input is: curl):'
}
Cookbooks.blfs 'curl'
cliner; e
# =========================================================================== #
# Testing class AllUrls next.
# =========================================================================== #
cliner {
  e 'Testing class AllUrls next:'
}
Cookbooks.all_urls
cliner; e
e 'Next we will test individual cookbook-entries:'
e
# =========================================================================== #
# === test_this_input
#
# With this method we can test the compilation.
# =========================================================================== #
def test_this_input(i)
  i = i.to_s
  _ = Cookbooks::Cookbook.new(i, :dont_run_yet)
  _.be_verbose
  _.full_report
  _.run
  e 'Is '+sfancy(i.to_s)+' included? '+vt(_.is_included?)
end
test_this_input :parted
test_this_input :libparted

e 'Next testing the individual Cookbook:'
cookbook = Cookbooks::Cookbook.new('ruby')
cookbook.feedback_make_options

object = Cookbooks::SanitizeCookbookDataset.new('jpeg')
# =========================================================================== #
# === test
# =========================================================================== #
def test(*i)
  i.flatten.each {|name|
    dataset = Cookbooks::SanitizeCookbookDataset.new(name)
    dataset.report # Invoke .report to report the dataset.
  }
end
e 'Now testing the project called '+sfancy('sanitize_cookbook_dataset')+'.'
# =========================================================================== #
# Test five entries next.
# =========================================================================== #
array = %w( php ruby htop libx11 xterm )
e 'We will test this array next:'
pp array
test array
e sfancy('Next, we will test some setters and other methods:')
e
e simp('First, determine whether we will keep the archive extracted '\
       'or whether we will not.')
dataset = Cookbooks::SanitizeCookbookDataset.new('htop')
pp dataset.keep_extracted?
dataset.keep_extracted = false
pp dataset.keep_extracted?
e
e 'The file called registered_cookbook_entries.yml is stored here:'
e '  '+sfile(Cookbooks::SanitizeCookbookDataset.file_registered_cookbook_entries)
e
e ::Colours::Konsole.orange('Next testing '\
  'SanitizeCookbookDataset.feedback_all_available_formats')
Cookbooks::SanitizeCookbookDataset.feedback_all_available_formats
e
# =========================================================================== #
# === Show the main URLs of the program:
# =========================================================================== #
e 'Next, we will show the main URLs:'
pp object.urls?
e
e 'The available help options are:'
e
Cookbooks::SanitizeCookbookDataset.new('--help')
e